package com.ruoyi.web.base.controller;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.framework.web.service.TokenService;
import com.ruoyi.web.base.domain.BaseSalesTerritory;
import com.ruoyi.web.base.service.IBaseSalesTerritoryService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

import static com.ruoyi.common.core.domain.AjaxResult.success;
import static com.ruoyi.common.utils.SecurityUtils.getUsername;

/**
 * <p>
 * 销售区域 前端控制器
 * </p>
 *
 * @author author
 * @since 2026-02-03
 */
@RestController
@RequestMapping("/base-sales-territory")
public class BaseSalesTerritoryController {
    @Autowired
    private IBaseSalesTerritoryService baseSalesTerritoryService;
    @Autowired
    private TokenService tokenService;

    @ApiOperation("销售区域管理添加")
    @PostMapping("/add")
    public AjaxResult add(@RequestBody BaseSalesTerritory baseSalesTerritory, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (baseSalesTerritoryService.count(new QueryWrapper<BaseSalesTerritory>().eq("org_id",loginOrgId).eq("sales_territory_num", baseSalesTerritory.getSalesTerritoryNum())) >0 ){
            throw new Exception("该编号已存在");
        }

        baseSalesTerritory.setOrgId(loginOrgId);
        baseSalesTerritory.setCreateBy(getUsername());
        return success(baseSalesTerritoryService.save(baseSalesTerritory));
    }

    @ApiOperation("销售区域管理修改")
    @PostMapping("/edit")
    public AjaxResult edit(@RequestBody BaseSalesTerritory baseSalesTerritory, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (baseSalesTerritoryService.count(new QueryWrapper<BaseSalesTerritory>().ne("id",baseSalesTerritory.getId()).eq("org_id",loginOrgId).eq("sales_territory_num", baseSalesTerritory.getSalesTerritoryNum())) >0 ){
            throw new Exception("该编号已存在");
        }
        baseSalesTerritory.setUpdateBy(getUsername());
        return success(baseSalesTerritoryService.updateById(baseSalesTerritory));
    }

    @ApiOperation("销售区域管理删除")
    @PostMapping("/delete")
    public AjaxResult delete(@RequestBody Map<String, String> paramsMap) {
        String ids = paramsMap.get("ids");
        for (String s : ids.split(",")) {
            baseSalesTerritoryService.removeById(s);
        }
        return success();
    }

    @ApiOperation("销售区域管理列表")
    @PostMapping("/list")
    public AjaxResult listAll( HttpServletRequest request){
        return success(baseSalesTerritoryService.list(new QueryWrapper<BaseSalesTerritory>().eq("org_id",tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("销售区域管理分页")
    @GetMapping("/page")
    public AjaxResult page(@RequestParam("pageNum") Integer pageNum, @RequestParam("pageSize") Integer pageSize,HttpServletRequest request
    ) {
        return success(baseSalesTerritoryService.page(new Page<BaseSalesTerritory>(pageNum,pageSize),new QueryWrapper<BaseSalesTerritory>().eq("org_id",tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("销售区域管理详情")
    @PostMapping("/listById")
    public AjaxResult listById(@RequestBody Map<String, String> paramsMap){
        String id = paramsMap.get("id");
        return success(baseSalesTerritoryService.getById(id));
    }

}
